SFML 2.3.2

- Main Page
- Related Pages
- Modules
- Classes
- Files

- Class List
- Class Index
- Class Hierarchy
- Class Members

Public Types | Public Member Functions | Protected Member Functions | Protected Attributes | List of all members
sf::SoundSource Class Reference
Audio module

Base class defining a sound's properties. More...

`#include <SoundSource.hpp>`

Inheritance diagram for sf::SoundSource:

## Public Types
enum | Status { Stopped, Paused, Playing }
| Enumeration of the sound source states. More...

## Public Member Functions
| SoundSource (const SoundSource &copy)
| Copy constructor. More...
virtual | ~SoundSource ()
| Destructor. More...
void | setPitch (float pitch)
| Set the pitch of the sound. More...
void | setVolume (float volume)
| Set the volume of the sound. More...
void | setPosition (float x, float y, float z)
| Set the 3D position of the sound in the audio scene. More...
void | setPosition (const Vector3f &position)
| Set the 3D position of the sound in the audio scene. More...
void | setRelativeToListener (bool relative)
| Make the sound's position relative to the listener or absolute. More...
void | setMinDistance (float distance)
| Set the minimum distance of the sound. More...
void | setAttenuation (float attenuation)
| Set the attenuation factor of the sound. More...
float | getPitch () const
| Get the pitch of the sound. More...
float | getVolume () const
| Get the volume of the sound. More...
Vector3f | getPosition () const
| Get the 3D position of the sound in the audio scene. More...
bool | isRelativeToListener () const
| Tell whether the sound's position is relative to the listener or is absolute. More...
float | getMinDistance () const
| Get the minimum distance of the sound. More...
float | getAttenuation () const
| Get the attenuation factor of the sound. More...

## Protected Member Functions
| SoundSource ()
| Default constructor. More...
Status | getStatus () const
| Get the current status of the sound (stopped, paused, playing) More...

## Protected Attributes
unsigned int | m_source
| OpenAL source identifier. More...

## Detailed Description

Base class defining a sound's properties.

sf::SoundSource is not meant to be used directly, it only serves as a common base for all audio objects that can live in the audio environment.

It defines several properties for the sound: pitch, volume, position, attenuation, etc. All of them can be changed at any time with no impact on performances.

See also
  sf::Sound, sf::SoundStream

Definition at line 42 of file SoundSource.hpp.

## Member Enumeration Documentation

enum sf::SoundSource::Status

Enumeration of the sound source states.

Enumerator
Stopped | Sound is not playing.
Paused | Sound is paused.
Playing | Sound is playing.

Definition at line 50 of file SoundSource.hpp.

## Constructor & Destructor Documentation

sf::SoundSource::SoundSource | ( | const SoundSource & | copy | ) |

Copy constructor.

Parameters

  copy | Instance to copy

virtual sf::SoundSource::~SoundSource | ( |  | ) |
| virtual

Destructor.

sf::SoundSource::SoundSource | ( |  | ) |
| protected

Default constructor.

This constructor is meant to be called by derived classes only.

## Member Function Documentation

float sf::SoundSource::getAttenuation | ( |  | ) | const

Get the attenuation factor of the sound.

Returns
  Attenuation factor of the sound

See also
  setAttenuation, getMinDistance

float sf::SoundSource::getMinDistance | ( |  | ) | const

Get the minimum distance of the sound.

Returns
  Minimum distance of the sound

See also
  setMinDistance, getAttenuation

float sf::SoundSource::getPitch | ( |  | ) | const

Get the pitch of the sound.

Returns
  Pitch of the sound

See also
  setPitch

Vector3f sf::SoundSource::getPosition | ( |  | ) | const

Get the 3D position of the sound in the audio scene.

Returns
  Position of the sound

See also
  setPosition

Status sf::SoundSource::getStatus | ( |  | ) | const
| protected

Get the current status of the sound (stopped, paused, playing)

Returns
  Current status of the sound

float sf::SoundSource::getVolume | ( |  | ) | const

Get the volume of the sound.

Returns
  Volume of the sound, in the range [0, 100]

See also
  setVolume

bool sf::SoundSource::isRelativeToListener | ( |  | ) | const

Tell whether the sound's position is relative to the listener or is absolute.

Returns
  True if the position is relative, false if it's absolute

See also
  setRelativeToListener

void sf::SoundSource::setAttenuation | ( | float | attenuation | ) |

Set the attenuation factor of the sound.

The attenuation is a multiplicative factor which makes the sound more or less loud according to its distance from the listener. An attenuation of 0 will produce a non-attenuated sound, i.e. its volume will always be the same whether it is heard from near or from far. On the other hand, an attenuation value such as 100 will make the sound fade out very quickly as it gets further from the listener. The default value of the attenuation is 1.

Parameters

  attenuation | New attenuation factor of the sound

See also
  getAttenuation, setMinDistance

void sf::SoundSource::setMinDistance | ( | float | distance | ) |

Set the minimum distance of the sound.

The "minimum distance" of a sound is the maximum distance at which it is heard at its maximum volume. Further than the minimum distance, it will start to fade out according to its attenuation factor. A value of 0 ("inside the head of the listener") is an invalid value and is forbidden. The default value of the minimum distance is 1.

Parameters

  distance | New minimum distance of the sound

See also
  getMinDistance, setAttenuation

void sf::SoundSource::setPitch | ( | float | pitch | ) |

Set the pitch of the sound.

The pitch represents the perceived fundamental frequency of a sound; thus you can make a sound more acute or grave by changing its pitch. A side effect of changing the pitch is to modify the playing speed of the sound as well. The default value for the pitch is 1.

Parameters

  pitch | New pitch to apply to the sound

See also
  getPitch

void sf::SoundSource::setPosition | ( | float | x,
|  | float | y,
|  | float | z
| ) |  |

Set the 3D position of the sound in the audio scene.

Only sounds with one channel (mono sounds) can be spatialized. The default position of a sound is (0, 0, 0).

Parameters

  x | X coordinate of the position of the sound in the scene
  y | Y coordinate of the position of the sound in the scene
  z | Z coordinate of the position of the sound in the scene

See also
  getPosition

void sf::SoundSource::setPosition | ( | const Vector3f & | position | ) |

Set the 3D position of the sound in the audio scene.

Only sounds with one channel (mono sounds) can be spatialized. The default position of a sound is (0, 0, 0).

Parameters

  position | Position of the sound in the scene

See also
  getPosition

void sf::SoundSource::setRelativeToListener | ( | bool | relative | ) |

Make the sound's position relative to the listener or absolute.

Making a sound relative to the listener will ensure that it will always be played the same way regardless of the position of the listener. This can be useful for non-spatialized sounds, sounds that are produced by the listener, or sounds attached to it. The default value is false (position is absolute).

Parameters

  relative | True to set the position relative, false to set it absolute

See also
  isRelativeToListener

void sf::SoundSource::setVolume | ( | float | volume | ) |

Set the volume of the sound.

The volume is a value between 0 (mute) and 100 (full volume). The default value for the volume is 100.

Parameters

  volume | Volume of the sound

See also
  getVolume

## Member Data Documentation

unsigned int sf::SoundSource::m_source
| protected

OpenAL source identifier.

Definition at line 264 of file SoundSource.hpp.

The documentation for this class was generated from the following file:

- SoundSource.hpp